/**
 * Copyright (C) 2011 BonitaSoft S.A.
 * BonitaSoft, 31 rue Gustave Eiffel - 38000 Grenoble
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2.0 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.ow2.bonita.services;

import java.util.Date;

import org.ow2.bonita.facade.uuid.ProcessDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;

/**
 * 
 * @author Matthieu Chaffotte
 *
 */
public interface Document extends DocumentationObject {

  public String getAuthor();

  public Date getCreationDate();

  public String getLastModifiedBy();

  public Date getLastModificationDate();

  public boolean isLatestVersion();

  public boolean isMajorVersion();

  public String getVersionLabel();

  public String getVersionSeriesId();

  public String getContentMimeType();

  public String getContentFileName();

  public long getContentSize();
  
  public ProcessInstanceUUID getProcessInstanceUUID();

  public ProcessDefinitionUUID getProcessDefinitionUUID();
  
}
